# -*- encoding: utf-8 -*-
require 'omniauth-oauth2'
require 'cgi' unless defined?(::CGI)


module OmniAuth
  module Strategies
    class Taobao < OmniAuth::Strategies::OAuth2
      option :name, 'taobao'
      option :client_options, {
                 site: "https://oauth.taobao.com", # 
        authorize_url: "/authorize",
            token_url: "/token"
      }
      option :token_params, {
        parse: :json
      }

      uid do
        user_id
      end

      info do
        {
          nickname: nickname
        }
      end

      extra do
        {
          raw_info: {}
        }
      end

      private

      def nickname
        ::CGI::unescape(access_token.params['taobao_user_nick'].to_s).force_encoding('utf-8')
      end

      def user_id
        access_token.params['taobao_user_id'].to_i
      end
      
    end
  end
end

OmniAuth.config.add_camelization "taobao", "Taobao"